//*****************************************************************************
// File: queue.cc
// Implementation of the long_queue.
//*****************************************************************************

#include <stdio.h>
#include "queue.h"

void long_queue::clear()
{
   q_node	*temp;

   while (front != NULL) {
      temp = front->next;
      delete front;
      front = temp;
   }
   rear = NULL;
   queue_length = 0;
}


void long_queue::put(long item)
{
   q_node	*temp;

//printf("long_queue::put:item=%ld (old-len=%d)", item, queue_length);
   if ((temp = new q_node) == NULL) {
      fprintf(stderr, "class long_queue: put: Out of memory.\n");
      exit(1);
   }
   temp->info = item;
   temp->next = NULL;
   if (rear != NULL)
      rear->next = temp; 	// Queue was not empty.
   else
      front = temp;
   rear = temp;
   queue_length++;
//printf("(new-len=%ld)\n", queue_length);
}


long long_queue::get()
{
   q_node	*temp;
   long		item;

//printf("long_queue::get:");
   if (queue_length == 0) {
      fprintf(stderr, "class long_queue: get: Queue is empty.\n");
      exit(1);
   }
   temp = front->next;
   item = front->info;
   delete front;
   front = temp;
   if (front == NULL) rear = NULL;	// Queue is empty.
   queue_length--;
//printf("item=%ld ", item);
//printf("(new-len=%ld)\n", queue_length);
   return item;
}
